<?php 
error_reporting(0);

/*This script could be run on any PHP version
 * We want to make sure that we are not running
 * Less than 5.3.3, otherwise, warnings might
 * result.
 * */
if (!version_compare(PHP_VERSION, '5.3.3','>='))
    die('PHP version not supported');

//Don't connect to the db, we don't have the settings yet
$no_db_connect = "0";
require_once  __DIR__.'/../include/global.php';

include_once TSEP_INCLUDE_DIR.'/class.setup.php';
$setup = new SetupInstaller();

session_start();


if ($_GET['Step'] == NULL){
    $_SESSION = array();  
    $step = null;
}  
else {
	$step = $_SESSION['Step'];
	if ($_GET['Step']=="next")
	    $step++;
	if ($_GET['Step']=="back")
	    $step--;    
}

//Parse the post data

if ($_SERVER['REQUEST_METHOD'] == "POST") {
	
	if ($step == 8){
       $setup->connectToDb();
	}
	if ($step == 10){
		$setup->addSecurity();
	}
}

if (($step == null)) {
	$step = 0;
	
?>
<!DOCTYPE unspecified PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
    <head>
        <title>Welcome to TSEP</title>
        <script type="text/javascript">
        
        xmlhttp = new XMLHttpRequest();
           
            xmlhttp.open("GET", "setup.php?Step=next",true);
             xmlhttp.onreadystatechange=function() {
              if (xmlhttp.readyState==4) {
                   eval(xmlhttp.responseText);
              }
             };
             xmlhttp.send(null);

        </script>
    </head>
    <body>
    <!--[if IE]>
       <script type="text/javascript"> 
        alert("Your Browser seems to not be compatible with the new setup.\n" + 
            "It is recommeded that you upgrade to a newer browser, like\n" +
            "Chrome 6, Safari 5, FireFox 3.6, or Opera 10.50. You will now be \n" +
            "Redirected to our older setup, which supports older browsers.");
         window.location = "setup.old.php";
        </script>
    <![endif]-->
        <center style="margin-top:30%;">
            <h4>Loading, Please Wait...</h4>
        </center>
    </body>

</html>


<?php 


}



if ($step== 1) {
	
	header("Content-type: text/javascript");
	?>
	//for Backward Comaptibility only (shame to all browsers that need this):
	document.head = document.head || document.getElementsByTagName('head')[0];
	
	
	xmlhttp = new XMLHttpRequest();
           
            xmlhttp.open("GET", "js/setup.js",true);
             xmlhttp.onreadystatechange=function() {
              if (xmlhttp.readyState==4) {
                   var scriptElement = document.createElement("script");
                   
                   scriptElement.type = "text/javascript";
                   scriptElement.text = xmlhttp.responseText;
                   
                   document.head.appendChild(scriptElement);
              }
             };
    xmlhttp.send(null);
    
    
	
	<?php 
	
	
}

if($step==2) {
    
    include TSEP_INCLUDE_DIR.'/lang.html';
}

if ($step==3) {
	
	//MultiLanguage not Implemented yet
	$_SESSION['Language'] = $_GET['Lang'];
	
	?>
	<div id="sidebar">
	  <table>
	       <tr><td class="sidebarTD" id="step_1">Introduction</td></tr>
	       <tr><td class="sidebarTD" id="step_2">Check Environment</td></tr>
	       <tr><td class="sidebarTD" id="step_3">Connect to Database</td></tr>
	       <tr><td class="sidebarTD" id="step_4">Setup Database</td></tr>
	       <tr><td class="sidebarTD" id="step_5">Enter Settings</td></tr>
	       <tr><td class="sidebarTD" id="step_6">Complete Setup</td></tr>
	  </table> 
	</div>
	<div id="placeholder"><br /></div>
	<div id="step">
	  <center><div style="margin-top:40%;">Loading...</div></center>
	</div>
	
	
	
	
	<?php 
	   $setup->initSetup();
	
}
if ($step==4){
    include __DIR__.'/css/setup.css';	
}

if ($step==5){
	
	?>
	<div id="is">
	<h2>Welcome to TSEP.</h2>
	<p>
	Thank you for considering to use TSEP.<br /><br />
    You are installing TSEP. This installer will take you through the process of setting up or upgrading <span class="tsep">TSEP</span>. On the left side of the screen you see the steps to take before the installation is complete. You will be able to track the progress of the installation by checking those steps.<br /><br />
    We have taken great care to select the default options for you. If this is your first install we suggest you accept the default values and tweak them as you learn how to use <span class="tsep">TSEP</span>. If you're upgrading from an older version of <span class="tsep">TSEP</span> the installer determines your old settings. You'll be able to copy them to the new setup or accept the default values.<br /><br />
    We hope TSEP proves to be a valuable tool for your website.<br />
    If you have any questions or comments please contact us through our forum at our <a href="http://sourceforge.net/projects/tsep/" target="blank">SourceForge site</a>.<br /><br />
    The TSEP Team<br />
    </p>
    
    <a href="javascript:void(0)" class="cssbutton" onClick="loadStep('next');">Next</a>
    
	</div>
	
	<?php 
	
}

if ($step == 6){
	
	?>
	
	<div id="is">
	
	<h2>Checking the Environment</h2>
	
	
	<table>
		<?php foreach ($setup->CheckEnv() as $envCheck) { ?>
			<tr>
			    <?php if ($envCheck['status'] == true){ ?>
			     <td class="checkMark"> <?php echo $envCheck['message']; ?></td>
			    <?php } else {?>
			     <td class="xMark"><?php echo $envCheck['message']; ?></td>
			    <?php }?>
		    </tr>
		<?php } ?>
	</table>
	
	    <a href="javascript:void(0)" class="cssbutton" onClick="loadStep('back');">Back</a> <a href="javascript:void(0)" class="cssbutton" onClick="loadStep('next');">Next</a> 
	    
	
	</div>	
	
	<?php 
	      
}
if ($step==7){
	
		
        
	?>
	<div id="is">
		<h2>Connect to the Database</h2>
		
			<?php if(($_SESSION['USER_ERROR']!= NULL)&&($_SESSION['ERROR_DETAILS']!= NULL)){ ?>
			<form>
				<span style="color:FF6633;"><?php echo $_SESSION['USER_ERROR'];?></span> <a href="javascript:void()" onclick="viewError();">View Details</a>
				<input type="hidden" id="ErrorDetails" value="<?php echo $_SESSION['ERROR_DETAILS'];?>"/>
			</form>
		<?php }
		      $_SESSION['USER_ERROR'] = NULL;
		?>
		
		<form id="mf" action="setup.php?Step=next" method="post">
			<table>
			<tr><td style="text-align:right;">Mysql Server Address:  </td><td><input value="<?php echo $_SESSION['FORM_1'][0]; ?>" type="text" name="server" />     </td></tr>
			<tr><td style="text-align:right;">Mysql Port:            </td><td><input value="<?php echo $_SESSION['FORM_1'][1]; ?>" type="text" name="port" />       </td></tr>
			<tr><td style="text-align:right;">Mysql Table Prefix:    </td><td><input value="<?php echo $_SESSION['FORM_1'][2];?>" type="text" name="prefix" />      </td></tr>
			<tr><td style="text-align:right;">Mysql Username:        </td><td><input value="<?php echo $_SESSION['FORM_1'][3];?>" type="text" name="uname" />       </td></tr>
			<tr><td style="text-align:right;">Mysql Password:        </td><td><input value="<?php echo $_SESSION['FORM_1'][4];?>" type="password" name="passwd" />  </td></tr>
			<tr><td style="text-align:right;">Mysql Database Name:   </td><td><input value="<?php echo $_SESSION['FORM_1'][5];?>" type="text" name="dbname" />      </td></tr>
			</table>
		</form>
		
		
		<a href="javascript:void(0)" class="cssbutton" onClick="loadStep('back');">Back</a> <a href="javascript:void(0)" class="cssbutton" onClick="loadStep('next');">Next</a> 
	</div>
	
	<?php 

		 
        
        
		
	
}
if ($step==8) {
    
        
     include_once TSEP_INCLUDE_DIR.'/class.db.php';

	?>
<div id="is">
<h2>Database Set Up</h2>
<p>
You are about to install TSEP on <?php echo $_SERVER['HTTP_HOST']; ?>. This is the final confimation
before installing TSEP. Please make sure that all of the settings are correct, and that the configuration
that you have selected is acceptable. Click Next to begin the installation.
</p>
<p>
Please note that you will not be able to go back after the installation. All values are final. Also, depending
on your server, the installation might take a minute, so be patient.
</p>
<a href="javascript:void(0)" class="cssbutton" onClick="loadStep('back');">Back</a> <a href="javascript:void(0)" class="cssbutton" onClick="loadStep('next');">Next</a> 

</div>

<?php
}

if ($step==9){

	
         
    include_once TSEP_INCLUDE_DIR.'/class.db.php';
    
    
    /* OK, Everyone here is where the fun begins!
     * Now, We need to insert the default values
     * Into the database. 
     * */
    
	?>
	<div id="is">
	<h2>TSEP Installed Successfully.</h2>
	<p>
	TSEP has been installed successfully on <?php echo $_SERVER['HTTP_HOST']; ?>.
	<br />
	Below is the Output from the installer: 
	<br />
	<textarea rows="10" cols="80" readonly="readonly" wrap="off">
<?php $setup->install($db_table_prefix); ?>
	</textarea>
	<br />
	
	Please Enter the settings below to complete installation.
	</p>
	
	<form id="mf" action="setup.php?Step=next">
	<table>
	<tr><td style="text-align:right;">Admin Username</td><td><input type="text" name="usrname" /></td></tr>
	<tr><td style="text-align:rigth;">Admin Password</td><td><input type="password"	name="passwd" /></td></tr>
	<!-- TODO:ADD OPTION TO INSERT FIRST INDEXING PROFILE -->
	</table>
	</form>
	
	
	<a href="javascript:void(0)" class="cssbutton" onClick="loadStep('next');">Next</a> 
	</div>
	
	
	
	<?php
	

	

}

if ($step==10){
	?>
	<div id="is">
	<h2>Setup Complete</h2>
	
	<p>Thank you for installing TSEP on your site.</p>
	<p><a href="<?php echo TSEP_CLIENT_ROOT; ?>/admin/index.php">Click Here to visit the admin area</a></p>
	<p><a href="<?php echo TSEP_CLIENT_ROOT;?>/search.php">Click Here to visit your search page</a></p> 
	
	</div>
	
	<?php 
}

$_SESSION['Step'] = $step;
?>