<?php
/** class.db.php
 *  
 *  This file is a copy of the text currently inside global.php
 *  In the future the text in global.php will be removed, and
 *  All pages will have to manually include this file to connect
 *  to the database. This is so pages can get constants stored in
 *  global.php without requiring a connection, improving efficiency
 * 
 * */

// Reading the data 
    $infotxt = file_get_contents(TSEP_ROOT_DIR."/include/dbconf.txt"); 
    
    if ($infotxt == null) {
        
        header("Location:".TSEP_CLIENT_ROOT."admin/setup.php");
        die();
    }
    
    //Decode the data
    $info = unserialize($infotxt); 
    
    
    
    /* URL to your database server */
    $db_server = $info['db_server'];
    /* Your database login name */
    $db_usrname = $info['db_usrname'];
    /* Your database password */
    $db_pwd = $info['db_pwd'];
    /* TSEP database name */
    $db_name = $info['db_name'];
    /* TSEP table prefix */
    global $db_table_prefix;
    $db_table_prefix = $info['db_table_prefix'];
    
    unset($info);
    unset($infotxt);
    
    error_reporting(E_ALL);
    
    /* Force the browser to use UTF-8 enconding */
    header("Content-type: text/html; charset=utf-8");
    header("Content-Transfer-Encoding: 8bit");
    
    //stop caching dynamic pages
    //from http://de3.php.net/header 
    // Date in the past
    header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
    // always modified
    header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
    // HTTP/1.1
    header("Cache-Control: no-store, no-cache, must-revalidate");
    header("Cache-Control: post-check=0, pre-check=0", false);
    // HTTP/1.0
    header("Pragma: no-cache");
    
    date_default_timezone_set('America/Chicago');
    
    
    error_reporting(0);
    /* Get the TSEP root folder */
    if ( !mysql_pconnect( $db_server, $db_usrname, $db_pwd ) ) {
        ?>
        <!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
           <html>
            <head><title>TSEP Fatal Error</title></head>
            <body>
                <p><b>TSEP could not establish a connection to the database.</b><br />
                The following error occured:<br />
                <pre><?php echo mysql_error();?></pre>
                </p>
                <p><i>Powered By: <a href="http://tsep.sf.net/">TSEP</a></i></p>
            </body>
        </html>
        <?php
        die();
    }
    if ( !mysql_select_db( $db_name ) ) {
        ?>
        <!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
        <html>
            <head><title>TSEP Fatal Error</title></head>
            <body>
                <p><b>TSEP could not open the database.</b></p><br />
                The Following error occured:<br />
                <pre><?php echo mysql_error();?></pre>
                <p><i>Powered By: <a href="http://tsep.sf.net/">TSEP</a></i></p>
            </body>
        </html>
        <?php
        die();
    }
    
    error_reporting(E_ALL);
    
    //Clean up the login data, as to prevent accidentally printing it later
    unset($db_name);
    unset($db_pwd);
    unset($db_server);
    unset($db_usrname);
    
    
    
    //Handle all errors
    require_once  TSEP_INCLUDE_DIR.'/class.errorhandler.php';
    
    /* general config data */
    require_once TSEP_INCLUDE_DIR.'/class.configuration.php';
    
    
    /* read language strings */
    /* include for security - if admin enters something that does not exist */
    /* always read english language as some (new) strings might not have been translated */
    include( TSEP_ROOT_DIR."/language/en_US/language.php" );
    /* code recycle: get language strings from fitting language.php */
    include( TSEP_ROOT_DIR."/language/".$tsep_config['Language']."/language.php" );
    /* handles language related issues */
    require_once( TSEP_ROOT_DIR."/include/languagehandler.php" );
    
    /* Include debug framework */
    require_once( TSEP_ROOT_DIR."/include/tseptrace.php" );
    ?>